diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-remote-station-manager.cc ns-3.34/src/wifi/model/wifi-remote-station-manager.cc
--- ns-3.33/src/wifi/model/wifi-remote-station-manager.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-remote-station-manager.cc	2021-07-14 10:31:07.000000000 -0700
@@ -972,38 +1156,36 @@
   //Last fragment
   if (fragmentNumber == nFragment - 1)
     {
-      uint32_t lastFragmentSize = packet->GetSize () - (fragmentNumber * (GetFragmentationThreshold () - header->GetSize () - WIFI_MAC_FCS_LENGTH));
+      uint32_t lastFragmentSize = mpdu->GetPacket ()->GetSize () - (fragmentNumber * (GetFragmentationThreshold () - mpdu->GetHeader ().GetSize () - WIFI_MAC_FCS_LENGTH));
       NS_LOG_DEBUG ("WifiRemoteStationManager::GetFragmentSize returning " << lastFragmentSize);
       return lastFragmentSize;
     }
   //All fragments but the last, the number of bytes is (Threshold - WIFI_HEADER_SIZE - WIFI_FCS).
   else
     {
-      uint32_t fragmentSize = GetFragmentationThreshold () - header->GetSize () - WIFI_MAC_FCS_LENGTH;
+      uint32_t fragmentSize = GetFragmentationThreshold () - mpdu->GetHeader ().GetSize () - WIFI_MAC_FCS_LENGTH;
       NS_LOG_DEBUG ("WifiRemoteStationManager::GetFragmentSize returning " << fragmentSize);
       return fragmentSize;
     }
 }
 
 uint32_t
-WifiRemoteStationManager::GetFragmentOffset (Mac48Address address, const WifiMacHeader *header,
-                                             Ptr<const Packet> packet, uint32_t fragmentNumber)
+WifiRemoteStationManager::GetFragmentOffset (Ptr<const WifiMacQueueItem> mpdu, uint32_t fragmentNumber)
 {
-  NS_LOG_FUNCTION (this << address << *header << packet << fragmentNumber);
-  NS_ASSERT (!address.IsGroup ());
-  NS_ASSERT (fragmentNumber < GetNFragments (header, packet));
-  uint32_t fragmentOffset = fragmentNumber * (GetFragmentationThreshold () - header->GetSize () - WIFI_MAC_FCS_LENGTH);
+  NS_LOG_FUNCTION (this << *mpdu << fragmentNumber);
+  NS_ASSERT (!mpdu->GetHeader ().GetAddr1 ().IsGroup ());
+  NS_ASSERT (fragmentNumber < GetNFragments (mpdu));
+  uint32_t fragmentOffset = fragmentNumber * (GetFragmentationThreshold () - mpdu->GetHeader ().GetSize () - WIFI_MAC_FCS_LENGTH);
   NS_LOG_DEBUG ("WifiRemoteStationManager::GetFragmentOffset returning " << fragmentOffset);
   return fragmentOffset;
 }
 
 bool
-WifiRemoteStationManager::IsLastFragment (Mac48Address address, const WifiMacHeader *header,
-                                          Ptr<const Packet> packet, uint32_t fragmentNumber)
+WifiRemoteStationManager::IsLastFragment (Ptr<const WifiMacQueueItem> mpdu, uint32_t fragmentNumber)
 {
-  NS_LOG_FUNCTION (this << address << *header << packet << fragmentNumber);
-  NS_ASSERT (!address.IsGroup ());
-  bool isLast = fragmentNumber == (GetNFragments (header, packet) - 1);
+  NS_LOG_FUNCTION (this << *mpdu << fragmentNumber);
+  NS_ASSERT (!mpdu->GetHeader ().GetAddr1 ().IsGroup ());
+  bool isLast = fragmentNumber == (GetNFragments (mpdu) - 1);
   NS_LOG_DEBUG ("WifiRemoteStationManager::IsLastFragment returning " << std::boolalpha << isLast);
   return isLast;
 }
@@ -1021,6 +1203,26 @@
   return state->m_info;
 }
 
+double
+WifiRemoteStationManager::GetMostRecentRssi (Mac48Address address) const
+{
+  double rssi = 0.0;
+  Time mostRecentUpdateTime = NanoSeconds (0);
+  for (const auto & station : m_stations)
+    {
+      if (station->m_state->m_address == address) //get most recent RSSI irrespective of TID
+        {
+          if (station->m_rssiAndUpdateTimePair.second >= mostRecentUpdateTime)
+            {
+              rssi = station->m_rssiAndUpdateTimePair.first;
+              mostRecentUpdateTime = station->m_rssiAndUpdateTimePair.second;
+            }
+        }
+    }
+  NS_ASSERT (mostRecentUpdateTime.IsStrictlyPositive ());
+  return rssi;
+}
+
 WifiRemoteStationState *
 WifiRemoteStationManager::LookupState (Mac48Address address) const
 {
@@ -1038,6 +1240,9 @@
   state->m_address = address;
   state->m_operationalRateSet.push_back (GetDefaultMode ());
   state->m_operationalMcsSet.push_back (GetDefaultMcs ());
+  state->m_dsssSupported = false;
+  state->m_erpOfdmSupported = false;
+  state->m_ofdmSupported = false;
   state->m_htCapabilities = 0;
   state->m_vhtCapabilities = 0;
   state->m_heCapabilities = 0;
@@ -1066,6 +1271,7 @@
 
   WifiRemoteStation *station = DoCreateStation ();
   station->m_state = state;
+  station->m_rssiAndUpdateTimePair = std::make_pair (0, Seconds (0));
   const_cast<WifiRemoteStationManager *> (this)->m_stations.push_back (station);
   return station;
 }
@@ -1095,10 +1301,9 @@
       state->m_channelWidth = 20;
     }
   SetQosSupport (from, true);
-  for (uint8_t j = 0; j < m_wifiPhy->GetNMcs (); j++)
+  for (const auto & mcs : m_wifiPhy->GetMcsList (WIFI_MOD_CLASS_HT))
     {
-      WifiMode mcs = m_wifiPhy->GetMcs (j);
-      if (mcs.GetModulationClass () == WIFI_MOD_CLASS_HT && htCapabilities.IsSupportedMcs (mcs.GetMcsValue ()))
+      if (htCapabilities.IsSupportedMcs (mcs.GetMcsValue ()))
         {
           AddSupportedMcs (from, mcs);
         }
@@ -1129,10 +1334,9 @@
     }
   for (uint8_t i = 1; i <= m_wifiPhy->GetMaxSupportedTxSpatialStreams (); i++)
     {
-      for (uint8_t j = 0; j < m_wifiPhy->GetNMcs (); j++)
+      for (const auto & mcs : m_wifiPhy->GetMcsList (WIFI_MOD_CLASS_VHT))
         {
-          WifiMode mcs = m_wifiPhy->GetMcs (j);
-          if (mcs.GetModulationClass () == WIFI_MOD_CLASS_VHT && vhtCapabilities.IsSupportedMcs (mcs.GetMcsValue (), i))
+          if (vhtCapabilities.IsSupportedMcs (mcs.GetMcsValue (), i))
             {
               AddSupportedMcs (from, mcs);
             }
@@ -1185,12 +1389,10 @@
     }
   for (uint8_t i = 1; i <= m_wifiPhy->GetMaxSupportedTxSpatialStreams (); i++)
     {
-      for (uint8_t j = 0; j < m_wifiPhy->GetNMcs (); j++)
+      for (const auto & mcs : m_wifiPhy->GetMcsList (WIFI_MOD_CLASS_HE))
         {
-          WifiMode mcs = m_wifiPhy->GetMcs (j);
-          if (mcs.GetModulationClass () == WIFI_MOD_CLASS_HE
-              && heCapabilities.GetHighestNssSupported () >= i
-              && heCapabilities.GetHighestMcsSupported () >= j)
+          if (heCapabilities.GetHighestNssSupported () >= i
+              && heCapabilities.GetHighestMcsSupported () >= mcs.GetMcsValue ())
             {
               AddSupportedMcs (from, mcs);
             }
@@ -1219,18 +1421,6 @@
 }
 
 bool
-WifiRemoteStationManager::GetGreenfieldSupported (Mac48Address address) const
-{
-  Ptr<const HtCapabilities> htCapabilities = LookupState (address)->m_htCapabilities;
-
-  if (!htCapabilities)
-    {
-      return false;
-    }
-  return htCapabilities->GetGreenfield ();
-}
-
-bool
 WifiRemoteStationManager::GetLdpcSupported (Mac48Address address) const
 {
   Ptr<const HtCapabilities> htCapabilities = LookupState (address)->m_htCapabilities;
@@ -1424,7 +1614,7 @@
 }
 
 void
-WifiRemoteStationManager::DoReportAmpduTxStatus (WifiRemoteStation *station, uint8_t nSuccessfulMpdus, uint8_t nFailedMpdus, double rxSnr, double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
+WifiRemoteStationManager::DoReportAmpduTxStatus (WifiRemoteStation *station, uint16_t nSuccessfulMpdus, uint16_t nFailedMpdus, double rxSnr, double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
 {
   NS_LOG_DEBUG ("DoReportAmpduTxStatus received but the manager does not handle A-MPDUs!");
 }
@@ -1502,18 +1692,6 @@
 }
 
 bool
-WifiRemoteStationManager::GetGreenfield (const WifiRemoteStation *station) const
-{
-  Ptr<const HtCapabilities> htCapabilities = station->m_state->m_htCapabilities;
-
-  if (!htCapabilities)
-    {
-      return false;
-    }
-  return htCapabilities->GetGreenfield ();
-}
-
-bool
 WifiRemoteStationManager::GetAggregation (const WifiRemoteStation *station) const
 {
   return station->m_state->m_aggregation;
@@ -1637,6 +1815,24 @@
 }
 
 bool
+WifiRemoteStationManager::GetDsssSupported (const Mac48Address& address) const
+{
+  return (LookupState (address)->m_dsssSupported);
+}
+
+bool
+WifiRemoteStationManager::GetErpOfdmSupported (const Mac48Address& address) const
+{
+  return (LookupState (address)->m_erpOfdmSupported);
+}
+
+bool
+WifiRemoteStationManager::GetOfdmSupported (const Mac48Address& address) const
+{
+  return (LookupState (address)->m_ofdmSupported);
+}
+
+bool
 WifiRemoteStationManager::GetHtSupported (Mac48Address address) const
 {
   return (LookupState (address)->m_htCapabilities != 0);
@@ -1673,12 +1869,6 @@
 }
 
 bool
-WifiRemoteStationManager::UseGreenfieldForDestination (Mac48Address dest) const
-{
-  return (GetGreenfieldSupported () && GetGreenfieldSupported (dest) && !GetUseGreenfieldProtection ());
-}
-
-bool
 WifiRemoteStationManager::UseLdpcForDestination (Mac48Address dest) const
 {
   return (GetLdpcSupported () && GetLdpcSupported (dest));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-remote-station-manager.h ns-3.34/src/wifi/model/wifi-remote-station-manager.h
--- ns-3.33/src/wifi/model/wifi-remote-station-manager.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-remote-station-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -30,9 +30,9 @@
 #include "wifi-utils.h"
 #include "qos-utils.h"
 #include "wifi-remote-station-info.h"
-#include "ht-capabilities.h"
-#include "vht-capabilities.h"
-#include "he-capabilities.h"
+#include "ns3/ht-capabilities.h"
+#include "ns3/vht-capabilities.h"
+#include "ns3/he-capabilities.h"
 
 namespace ns3 {
 
@@ -40,9 +40,11 @@
 class WifiMac;
 class WifiMacHeader;
 class Packet;
+class WifiMacQueueItem;
 class WifiTxVector;
 
 struct WifiRemoteStationState;
+struct RxSignalInfo;
 
 /**
  * \brief hold per-remote-station state.
@@ -58,7 +60,8 @@
 struct WifiRemoteStation
 {
   virtual ~WifiRemoteStation () {};
-  WifiRemoteStationState *m_state;  //!< Remote station state
+  WifiRemoteStationState *m_state;                 //!< Remote station state
+  std::pair<double, Time> m_rssiAndUpdateTimePair; //!< RSSI (in dBm) of the most recent packet received from the remote station along with update time
 };
 
 /**
@@ -90,10 +93,12 @@
   WifiModeList m_operationalMcsSet;  //!< operational MCS set
   Mac48Address m_address;            //!< Mac48Address of the remote station
   WifiRemoteStationInfo m_info;      //!< remote station info
+  bool m_dsssSupported;              //!< Flag if DSSS is supported by the remote station
+  bool m_erpOfdmSupported;           //!< Flag if ERP OFDM is supported by the remote station
+  bool m_ofdmSupported;              //!< Flag if OFDM is supported by the remote station
   Ptr<const HtCapabilities> m_htCapabilities;   //!< remote station HT capabilities
   Ptr<const VhtCapabilities> m_vhtCapabilities; //!< remote station VHT capabilities
   Ptr<const HeCapabilities> m_heCapabilities;   //!< remote station HE capabilities
-
   uint16_t m_channelWidth;    //!< Channel width (in MHz) supported by the remote station
   uint16_t m_guardInterval;   //!< HE Guard interval duration (in nanoseconds) supported by the remote station
   uint8_t m_ness;             //!< Number of extended spatial streams of the remote station
@@ -153,6 +158,16 @@
   virtual void SetupMac (const Ptr<WifiMac> mac);
 
   /**
+   * Assign a fixed random variable stream number to the random variables
+   * used by this model.  Return the number of streams (possibly zero) that
+   * have been assigned.
+   *
+   * \param stream first stream index to use
+   * \return the number of stream indices assigned by this model
+   */
+  virtual int64_t AssignStreams (int64_t stream);
+
+  /**
    * Sets the maximum STA short retry count (SSRC).
    *
    * \param maxSsrc the maximum SSRC
@@ -184,11 +199,6 @@
    * \param threshold the fragmentation threshold
    */
   void SetFragmentationThreshold (uint32_t threshold);
-  /**
-   * Typically called to update the fragmentation threshold at the start of a new transmission.
-   * This avoid that the fragmentation threshold gets changed during a transmission (see bug 730).
-   */
-  void UpdateFragmentationThreshold (void);
 
   /**
    * Records QoS support of the remote station.
@@ -258,24 +268,6 @@
    */
   bool GetHeSupported (void) const;
   /**
-   * Enable or disable PCF capability support.
-   *
-   * \param enable enable or disable PCF capability support
-   */
-  void SetPcfSupported (bool enable);
-  /**
-   * Return whether the device has PCF capability support enabled.
-   *
-   * \return true if PCF capability support is enabled, false otherwise
-   */
-  bool GetPcfSupported (void) const;
-  /**
-   * Return whether the device has HT Greenfield support enabled.
-   *
-   * \return true if HT Grenfield support is enabled, false otherwise
-   */
-  bool GetGreenfieldSupported (void) const;
-  /**
    * Return whether the device has LDPC support enabled.
    *
    * \return true if LDPC support is enabled, false otherwise
@@ -320,19 +312,6 @@
    */
   bool GetUseNonHtProtection (void) const;
   /**
-   * Enable or disable protection for stations that do not support HT Greenfield format.
-   *
-   * \param enable enable or disable protection for stations that do not support HT Greenfield format
-   */
-  void SetUseGreenfieldProtection (bool enable);
-  /**
-   * Return whether protection for stations that do not support HT Greenfield format is enabled.
-   *
-   * \return true if protection for stations that do not support HT Greenfield is enabled,
-   *         false otherwise
-   */
-  bool GetUseGreenfieldProtection (void) const;
-  /**
    * Enable or disable short PHY preambles.
    *
    * \param enable enable or disable short PHY preambles
@@ -407,15 +386,6 @@
    */
   WifiMode GetNonErpBasicMode (uint8_t i) const;
   /**
-   * Return whether the station supports Greenfield or not.
-   *
-   * \param address the address of the station
-   *
-   * \return true if Greenfield is supported by the station,
-   *         false otherwise
-   */
-  bool GetGreenfieldSupported (Mac48Address address) const;
-  /**
    * Return whether the station supports LDPC or not.
    *
    * \param address the address of the station
@@ -519,6 +489,33 @@
    */
   uint8_t GetNMcsSupported (Mac48Address address) const;
   /**
+   * Return whether the station supports DSSS or not.
+   *
+   * \param address the address of the station
+   *
+   * \return true if DSSS is supported by the station,
+   *         false otherwise
+   */
+  bool GetDsssSupported (const Mac48Address& address) const;
+  /**
+   * Return whether the station supports ERP OFDM or not.
+   *
+   * \param address the address of the station
+   *
+   * \return true if ERP OFDM is supported by the station,
+   *         false otherwise
+   */
+  bool GetErpOfdmSupported (const Mac48Address& address) const;
+  /**
+   * Return whether the station supports OFDM or not.
+   *
+   * \param address the address of the station
+   *
+   * \return true if OFDM is supported by the station,
+   *         false otherwise
+   */
+  bool GetOfdmSupported (const Mac48Address& address) const;
+  /**
    * Return whether the station supports HT or not.
    *
    * \param address the address of the station
@@ -669,6 +666,15 @@
    */
   WifiTxVector GetRtsTxVector (Mac48Address address);
   /**
+   * Return a TXVECTOR for the CTS frame given the destination and the mode of the RTS
+   * used by the sender.
+   *
+   * \param to the MAC address of the CTS receiver
+   * \param rtsTxMode the mode of the RTS used by the sender
+   * \return TXVECTOR for the CTS
+   */
+  WifiTxVector GetCtsTxVector (Mac48Address to, WifiMode rtsTxMode) const;
+  /**
    * Since CTS-to-self parameters are not dependent on the station,
    * it is implemented in wifi remote station manager
    *
@@ -676,72 +682,84 @@
    *         transmission of the data packet itself.
    */
   WifiTxVector GetCtsToSelfTxVector (void);
+  /**
+   * Return a TXVECTOR for the Ack frame given the destination and the mode of the Data
+   * used by the sender.
+   *
+   * \param to the MAC address of the Ack receiver
+   * \param dataTxVector the TXVECTOR of the Data used by the sender
+   * \return TXVECTOR for the Ack
+   */
+  WifiTxVector GetAckTxVector (Mac48Address to, const WifiTxVector& dataTxVector) const;
+  /**
+   * Return a TXVECTOR for the BlockAck frame given the destination and the mode of the Data
+   * used by the sender.
+   *
+   * \param to the MAC address of the BlockAck receiver
+   * \param dataTxVector the TXVECTOR of the Data used by the sender
+   * \return TXVECTOR for the BlockAck
+   */
+  WifiTxVector GetBlockAckTxVector (Mac48Address to, const WifiTxVector& dataTxVector) const;
+  /**
+   * Get control answer mode function.
+   *
+   * \param reqMode request mode
+   * \return control answer mode
+   */
+  WifiMode GetControlAnswerMode (WifiMode reqMode) const;
 
   /**
    * Should be invoked whenever the RtsTimeout associated to a transmission
    * attempt expires.
    *
-   * \param address the address of the receiver
    * \param header MAC header of the DATA packet
    */
-  void ReportRtsFailed (Mac48Address address, const WifiMacHeader *header);
+  void ReportRtsFailed (const WifiMacHeader& header);
   /**
    * Should be invoked whenever the AckTimeout associated to a transmission
    * attempt expires.
    *
-   * \param address the address of the receiver
-   * \param header MAC header of the DATA packet
-   * \param packetSize the size of the DATA packet
+   * \param mpdu the MPDU whose transmission failed
    */
-  void ReportDataFailed (Mac48Address address, const WifiMacHeader *header,
-                         uint32_t packetSize);
+  void ReportDataFailed (Ptr<const WifiMacQueueItem> mpdu);
   /**
    * Should be invoked whenever we receive the CTS associated to an RTS
    * we just sent. Note that we also get the SNR of the RTS we sent since
    * the receiver put a SnrTag in the CTS.
    *
-   * \param address the address of the receiver
    * \param header MAC header of the DATA packet
    * \param ctsSnr the SNR of the CTS we received
    * \param ctsMode the WifiMode the receiver used to send the CTS
    * \param rtsSnr the SNR of the RTS we sent
    */
-  void ReportRtsOk (Mac48Address address, const WifiMacHeader *header,
+  void ReportRtsOk (const WifiMacHeader& header,
                     double ctsSnr, WifiMode ctsMode, double rtsSnr);
   /**
    * Should be invoked whenever we receive the ACK associated to a data packet
    * we just sent.
    *
-   * \param address the address of the receiver
-   * \param header MAC header of the DATA packet
+   * \param mpdu the MPDU
    * \param ackSnr the SNR of the ACK we received
    * \param ackMode the WifiMode the receiver used to send the ACK
    * \param dataSnr the SNR of the DATA we sent
    * \param dataTxVector the TXVECTOR of the DATA we sent
-   * \param packetSize the size of the DATA packet
    */
-  void ReportDataOk (Mac48Address address, const WifiMacHeader *header,
-                     double ackSnr, WifiMode ackMode,
-                     double dataSnr, WifiTxVector dataTxVector,
-                     uint32_t packetSize);
+  void ReportDataOk (Ptr<const WifiMacQueueItem> mpdu, double ackSnr,
+                     WifiMode ackMode, double dataSnr, WifiTxVector dataTxVector);
   /**
    * Should be invoked after calling ReportRtsFailed if
    * NeedRetransmission returns false
    *
-   * \param address the address of the receiver
    * \param header MAC header of the DATA packet
    */
-  void ReportFinalRtsFailed (Mac48Address address, const WifiMacHeader *header);
+  void ReportFinalRtsFailed (const WifiMacHeader& header);
   /**
    * Should be invoked after calling ReportDataFailed if
    * NeedRetransmission returns false
    *
-   * \param address the address of the receiver
-   * \param header MAC header of the DATA packet
-   * \param packetSize the size of the DATA packet
+   * \param mpdu the MPDU which was discarded
    */
-  void ReportFinalDataFailed (Mac48Address address, const WifiMacHeader *header,
-                              uint32_t packetSize);
+  void ReportFinalDataFailed (Ptr<const WifiMacQueueItem> mpdu);
   /**
    * Typically called per A-MPDU, either when a Block ACK was successfully
    * received or when a BlockAckTimeout has elapsed.
@@ -754,17 +772,17 @@
    * \param dataSnr data SNR reported by remote station
    * \param dataTxVector the TXVECTOR of the MPDUs we sent
    */
-  void ReportAmpduTxStatus (Mac48Address address, uint8_t nSuccessfulMpdus, uint8_t nFailedMpdus,
+  void ReportAmpduTxStatus (Mac48Address address, uint16_t nSuccessfulMpdus, uint16_t nFailedMpdus,
                             double rxSnr, double dataSnr, WifiTxVector dataTxVector);
 
   /**
    * \param address remote address
-   * \param rxSnr the SNR of the packet received
-   * \param txMode the transmission mode used for the packet received
+   * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
+   * \param txVector the TXVECTOR used for the packet received
    *
    * Should be invoked whenever a packet is successfully received.
    */
-  void ReportRxOk (Mac48Address address, double rxSnr, WifiMode txMode);
+  void ReportRxOk (Mac48Address address, RxSignalInfo rxSignalInfo, WifiTxVector txVector);
 
   /**
    * \param header MAC header
@@ -785,55 +803,40 @@
   bool NeedCtsToSelf (WifiTxVector txVector);
 
   /**
-   * \param address remote address
-   * \param header MAC header
-   * \param packet the packet to send
+   * \param mpdu the MPDU to send
    *
    * \return true if we want to resend a packet after a failed transmission attempt,
    *         false otherwise.
    */
-  bool NeedRetransmission (Mac48Address address, const WifiMacHeader *header,
-                           Ptr<const Packet> packet);
+  bool NeedRetransmission (Ptr<const WifiMacQueueItem> mpdu);
   /**
-   * \param address remote address
-   * \param header MAC header
-   * \param packet the packet to send
+   * \param mpdu the MPDU to send
    *
    * \return true if this packet should be fragmented,
    *         false otherwise.
    */
-  bool NeedFragmentation (Mac48Address address, const WifiMacHeader *header,
-                          Ptr<const Packet> packet);
+  bool NeedFragmentation (Ptr<const WifiMacQueueItem> mpdu);
   /**
-   * \param address remote address
-   * \param header MAC header
-   * \param packet the packet to send
+   * \param mpdu the MPDU to send
    * \param fragmentNumber the fragment index of the next fragment to send (starts at zero).
    *
    * \return the size of the corresponding fragment.
    */
-  uint32_t GetFragmentSize (Mac48Address address, const WifiMacHeader *header,
-                            Ptr<const Packet> packet, uint32_t fragmentNumber);
+  uint32_t GetFragmentSize (Ptr<const WifiMacQueueItem> mpdu, uint32_t fragmentNumber);
   /**
-   * \param address remote address
-   * \param header MAC header
-   * \param packet the packet to send
+   * \param mpdu the packet to send
    * \param fragmentNumber the fragment index of the next fragment to send (starts at zero).
    *
    * \return the offset within the original packet where this fragment starts.
    */
-  uint32_t GetFragmentOffset (Mac48Address address, const WifiMacHeader *header,
-                              Ptr<const Packet> packet, uint32_t fragmentNumber);
+  uint32_t GetFragmentOffset (Ptr<const WifiMacQueueItem> mpdu, uint32_t fragmentNumber);
   /**
-   * \param address remote address
-   * \param header MAC header
-   * \param packet the packet to send
+   * \param mpdu the packet to send
    * \param fragmentNumber the fragment index of the next fragment to send (starts at zero).
    *
    * \return true if this is the last fragment, false otherwise.
    */
-  bool IsLastFragment (Mac48Address address, const WifiMacHeader *header,
-                       Ptr<const Packet> packet, uint32_t fragmentNumber);
+  bool IsLastFragment (Ptr<const WifiMacQueueItem> mpdu, uint32_t fragmentNumber);
 
   /**
    * \return the default transmission power
@@ -846,6 +849,16 @@
    */
   WifiRemoteStationInfo GetInfo (Mac48Address address);
   /**
+   * \param address of the remote station
+   *
+   * \return the RSSI (in dBm) of the most recent packet received from the remote station (irrespective of TID)
+   *
+   * This method is typically used when the device needs
+   * to estimate the target UL RSSI info to put in the
+   * Trigger frame to send to the remote station.
+   */
+  double GetMostRecentRssi (Mac48Address address) const;
+  /**
    * Set the default transmission power level
    *
    * \param txPower the default transmission power level
@@ -860,14 +873,6 @@
    */
   uint8_t GetMaxNumberOfTransmitStreams (void) const;
   /**
-   * \returns whether HT greenfield should be used for a given destination address.
-   *
-   * \param dest the destination address
-   *
-   * \return whether HT greenfield should be used for a given destination address
-   */
-  bool UseGreenfieldForDestination (Mac48Address dest) const;
-  /**
    * \returns whether LDPC should be used for a given destination address.
    *
    * \param dest the destination address
@@ -894,6 +899,19 @@
    */
   typedef void (*RateChangeTracedCallback)(DataRate oldRate, DataRate newRate, Mac48Address remoteAddress);
 
+  /**
+   * Return the WifiPhy.
+   *
+   * \return a pointer to the WifiPhy
+   */
+  Ptr<WifiPhy> GetPhy (void) const;
+  /**
+   * Return the WifiMac.
+   *
+   * \return a pointer to the WifiMac
+   */
+  Ptr<WifiMac> GetMac (void) const;
+
 
 protected:
   virtual void DoDispose (void);
@@ -1027,15 +1045,6 @@
    *         false otherwise
    */
   bool GetAggregation (const WifiRemoteStation *station) const;
-  /**
-   * Return whether the station supports Greenfield or not.
-   *
-   * \param station the station being queried
-   *
-   * \return true if Greenfield is supported by the station,
-   *         false otherwise
-   */
-  bool GetGreenfield (const WifiRemoteStation *station) const;
 
   /**
    * Return the number of supported streams the station has.
@@ -1054,21 +1063,19 @@
    */
   uint8_t GetNess (const WifiRemoteStation *station) const;
 
+
+private:
   /**
-   * Return the WifiPhy.
+   * If the given TXVECTOR is used for a MU transmission, return the STAID of
+   * the station with the given address if we are an AP or our own STAID if we
+   * are a STA associated with some AP. Otherwise, return SU_STA_ID.
    *
-   * \return a pointer to the WifiPhy
-   */
-  Ptr<WifiPhy> GetPhy (void) const;
-  /**
-   * Return the WifiMac.
-   *
-   * \return a pointer to the WifiMac
+   * \param address the address of the station
+   * \param txVector the TXVECTOR used for a MU transmission
+   * \return the STA-ID of the station
    */
-  Ptr<WifiMac> GetMac (void) const;
+  uint16_t GetStaId (Mac48Address address, const WifiTxVector& txVector) const;
 
-
-private:
   /**
    * \param station the station that we need to communicate
    * \param size the size of the frame to send in bytes
@@ -1208,7 +1215,7 @@
    * \param dataChannelWidth the channel width (in MHz) of the A-MPDU we sent
    * \param dataNss the number of spatial streams used to send the A-MPDU
    */
-  virtual void DoReportAmpduTxStatus (WifiRemoteStation *station, uint8_t nSuccessfulMpdus, uint8_t nFailedMpdus,
+  virtual void DoReportAmpduTxStatus (WifiRemoteStation *station, uint16_t nSuccessfulMpdus, uint16_t nFailedMpdus,
                                       double rxSnr, double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss);
 
   /**
@@ -1243,12 +1250,11 @@
   /**
    * Return the number of fragments needed for the given packet.
    *
-   * \param header MAC header
-   * \param packet the packet to be fragmented
+   * \param mpdu the packet to be fragmented
    *
    * \return the number of fragments needed
    */
-  uint32_t GetNFragments (const WifiMacHeader *header, Ptr<const Packet> packet);
+  uint32_t GetNFragments (Ptr<const WifiMacQueueItem> mpdu);
 
   /**
    * This is a pointer to the WifiPhy associated with this
@@ -1285,17 +1291,14 @@
   WifiMode m_defaultTxMode; //!< The default transmission mode
   WifiMode m_defaultTxMcs;  //!< The default transmission modulation-coding scheme (MCS)
 
-  bool m_pcfSupported; //!< Flag if PCF capability is supported
   uint32_t m_maxSsrc;  //!< Maximum STA short retry count (SSRC)
   uint32_t m_maxSlrc;  //!< Maximum STA long retry count (SLRC)
   uint32_t m_rtsCtsThreshold;             //!< Threshold for RTS/CTS
   uint32_t m_fragmentationThreshold;      //!< Current threshold for fragmentation
-  uint32_t m_nextFragmentationThreshold;  //!< Threshold for fragmentation that will be used for the next transmission
   uint8_t m_defaultTxPowerLevel;          //!< Default transmission power level
   WifiMode m_nonUnicastMode;      //!< Transmission mode for non-unicast Data frames
   bool m_useNonErpProtection;     //!< flag if protection for non-ERP stations against ERP transmissions is enabled
   bool m_useNonHtProtection;      //!< flag if protection for non-HT stations against HT transmissions is enabled
-  bool m_useGreenfieldProtection; //!< flag if protection for stations that do not support HT Greenfield format is enabled
   bool m_shortPreambleEnabled;    //!< flag if short PHY preamble is enabled
   bool m_shortSlotTimeEnabled;    //!< flag if short slot time is enabled
   ProtectionMode m_erpProtectionMode; //!< Protection mode for ERP stations when non-ERP stations are detected
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-spectrum-phy-interface.cc ns-3.34/src/wifi/model/wifi-spectrum-phy-interface.cc
--- ns-3.33/src/wifi/model/wifi-spectrum-phy-interface.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-spectrum-phy-interface.cc	2021-07-14 10:31:07.000000000 -0700
@@ -66,7 +66,7 @@
 }
 
 Ptr<MobilityModel>
-WifiSpectrumPhyInterface::GetMobility ()
+WifiSpectrumPhyInterface::GetMobility () const
 {
   return m_spectrumWifiPhy->GetMobility ();
 }
@@ -97,7 +97,7 @@
 }
 
 Ptr<AntennaModel>
-WifiSpectrumPhyInterface::GetRxAntenna (void)
+WifiSpectrumPhyInterface::GetRxAntenna (void) const
 {
   NS_LOG_FUNCTION (this);
   return m_spectrumWifiPhy->GetRxAntenna ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-spectrum-phy-interface.h ns-3.34/src/wifi/model/wifi-spectrum-phy-interface.h
--- ns-3.33/src/wifi/model/wifi-spectrum-phy-interface.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-spectrum-phy-interface.h	2021-07-14 10:31:07.000000000 -0700
@@ -53,19 +53,19 @@
    */
   void SetSpectrumWifiPhy (const Ptr<SpectrumWifiPhy> phy);
 
-  // Inherited from SpectrumPhy
-  Ptr<NetDevice> GetDevice () const;
-  void SetDevice (const Ptr<NetDevice> d);
-  void SetMobility (const Ptr<MobilityModel> m);
-  Ptr<MobilityModel> GetMobility ();
-  void SetChannel (const Ptr<SpectrumChannel> c);
-  Ptr<const SpectrumModel> GetRxSpectrumModel () const;
-  Ptr<AntennaModel> GetRxAntenna ();
-  void StartRx (Ptr<SpectrumSignalParameters> params);
+  Ptr<NetDevice> GetDevice () const override;
+  void SetDevice (const Ptr<NetDevice> d) override;
+  void SetMobility (const Ptr<MobilityModel> m) override;
+  Ptr<MobilityModel> GetMobility () const override;
+  void SetChannel (const Ptr<SpectrumChannel> c) override;
+  Ptr<const SpectrumModel> GetRxSpectrumModel () const override;
+  Ptr<AntennaModel> GetRxAntenna () const override;
+  void StartRx (Ptr<SpectrumSignalParameters> params) override;
 
 
 private:
-  virtual void DoDispose (void);
+  void DoDispose (void) override;
+
   Ptr<SpectrumWifiPhy> m_spectrumWifiPhy; ///< spectrum PHY
   Ptr<NetDevice> m_netDevice; ///< the device
   Ptr<SpectrumChannel> m_channel; ///< spectrum channel
